<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>homework4-fetch-data</title>
</head>
<body>
<h1>Star Wars</h1>
<ul id="film"></ul>
<!--AJAX це підхід, який використовує існуючі технології
( HTML CSS, JavaScript, DOM, XMLHttpRequest або fetch ін. сторонні пакети )
для ефективного управління завантаженням вмісту web-сторінки/частини без повного її перезавантаження.-->
<script>
            ( ( D ) => {
                fetch( 'https://ajax.test-danit.com/api/swapi/films' )
                    .then( res => res.json() )
                    .then( res => res.map( e => {
                            const { episodeId, characters, name, openingCrawl } = e;
                            return { episodeId, characters, name, openingCrawl };
                        })
                    )
                    .then( res => {
                        res.sort( ( a, b ) => a.episodeId > b.episodeId );
                        res.forEach( e => {
                            const liEpisode = D.createElement( 'li' ),
                                ulEpisode = D.createElement( 'ul' );
                            D.querySelector( '#film' ).appendChild( liEpisode ).appendChild( ulEpisode ).innerHTML =
                                `<h2>Episode:${ e.episodeId }</h2>`+
                                `<h3>${ e.name }</h3>`+
                                `<p>${ e.openingCrawl }</p>`;
                            e.characters.forEach( e => {
                                fetch( e )
                                    .then( res => res.json() )
                                    .then( res => {
                                        const liName = D.createElement( 'li' );
                                        ulEpisode.appendChild( liName ).append( res.name );
                                    });
                            });
                        });
                    })
                    .catch( error => console.log( error ) )
            })( document );
</script>
</body>
</html>